<?php

namespace Drupal\basket_paypal\FormAlters;

use Drupal\Core\Form\FormStateInterface;
use PayPalCheckoutSdk\Orders\OrdersGetRequest;
use PayPalCheckoutSdk\Payments\AuthorizationsGetRequest;

class OrderFormAlter {

  protected $payPalJs;
  protected $PayPal;

  public function __construct(){
    $this->payPalJs = \Drupal::getContainer()->get('PayPalJs');
  }

  public function orderForm(&$form, FormStateInterface $formState, $formId){
    $form['#attributes']['class'][] = 'js-paypal-order-form';
    $formDisplay = $formState->get('form_display');
    if(!empty($formDisplay)){
      if($paypalJs = $formDisplay->getComponent('paypal_js')){
        $form['paypal_js'] = [
          '#theme'        => 'basket_paypal_buttons',
          '#weight'       => $paypalJs['weight'] ?? '',
          '#attached'     => [
            'drupalSettings'  => [
              'basketPayPalJsSdk' => [
                'widgetSettings'  => $this->payPalJs->getWidgetInfo()
              ]
            ]
          ]
        ];
      }
    }
  }

}
